using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Security;
using System.Windows.Forms;
using mshtml;

namespace Alternative.Win32
{
	enum HRESULT
	{
		S_OK = 0,
		S_FALSE = 1,
	}

	[ComImport()]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("BD3F23C0-D43E-11CF-893B-00AA00BDCE1A")]
	interface IDocHostUIHandler
	{
		/// <summary>V[gJbgj[LɂB</summary>
		/// @retval S_OK zXg\AMSHTML ͕\ȂB
		/// @retval S_FALSE zXg͕\AMSHTML \B
		/// @retval DOCHOST_E_UNKNOWN ʎqsBMSHTL \B
		[PreserveSig]
		HRESULT ShowContextMenu(
			uint dwID,
			ref tagPOINT ppt,
			[MarshalAs(UnmanagedType.IUnknown)]
                object pcmdtReserved,
			[MarshalAs(UnmanagedType.IDispatch)]
                object pdispReserved);

		/// <summary>zXgԂB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void GetHostInfo(ref DOCHOSTUIINFO pInfo);

		/// <summary>MSHTML ̃j[c[o[uB</summary>
		/// @retval S_OK zXg\B
		/// @retval S_FALSE MSHTML \B
		/// @retval DOCHOST_E_UNKNOWN UI ʎqsBMSHTML \B
		[PreserveSig]
		HRESULT ShowUI(
			uint dwID,
			[In, MarshalAs(UnmanagedType.Interface)]
                object pActiveObject,
			[In, MarshalAs(UnmanagedType.Interface)]
                object pCommandTarget,
			[In, MarshalAs(UnmanagedType.Interface)]
                object pFrame,
			[In, MarshalAs(UnmanagedType.Interface)]
                object pDoc);

		/// <summary>j[ƃc[o[BB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void HideUI();

		/// <summary>R}hԂ̕ωʒmB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void UpdateUI();

		/// <summary>[_ UI \ɌĂяoB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void EnableModeless(int fEnable);

		/// <summary>EBhANeBuɌĂяoB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void OnDocWindowActivate(int fActivate);

		/// <summary>t[EBhANeBuɌĂяoB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void OnFrameWindowActivate(int fActivate);

		/// <summary>gTCYύXɌĂяoB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void ResizeBorder(ref tagRECT prcBorder,int pUIWindow,int fFrameWindow);

		/// <summary>L[͎ɌĂяoB</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		[PreserveSig]
		HRESULT TranslateAccelerator(ref tagMSG lpMsg,ref Guid pguidCmdGroup,uint nCmdID);

		/// <summary>Internet Explorer WXgݒɏ㏑TuL[pX擾B</summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void GetOptionKeyPath([MarshalAs(UnmanagedType.BStr)]ref string pchKey, uint dw);

		/// <summary>
		/// hbvzXgɒʒmB
		/// </summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		[PreserveSig]
		HRESULT GetDropTarget(
			[MarshalAs(UnmanagedType.Interface)] //*
                IDropTarget pDropTarget,
			[Out, MarshalAs(UnmanagedType.Interface)] //*
                out IDropTarget ppDropTarget);

		/// <summary>
		/// zXg IDispatch C^tF[X擾B
		/// </summary>
		/// @retval S_OK B
		/// @retval ̑ ُB
		void GetExternal(
			[MarshalAs(UnmanagedType.IDispatch)]
                out object ppDispatch);

		/// <summary>[h URL zXgŕύXB</summary>
		/// @retval S_OK B
		/// @retval S_FALSE URL FłȂB
		[PreserveSig]
		HRESULT TranslateUrl(
			uint dwTranslate,
			[MarshalAs(UnmanagedType.BStr)]
                string pchURLIn,
			[MarshalAs(UnmanagedType.BStr)]
                ref string ppchURLOut);

		/// <summary>zXg MSTML f[^IuWFNguB</summary>
		/// @retval S_OK uB
		/// @retval S_FALSE uȂB
		[PreserveSig]
		HRESULT FilterDataObject(
			[In, MarshalAs(UnmanagedType.Interface)]
                System.Runtime.InteropServices.ComTypes.IDataObject pDO,
			[MarshalAs(UnmanagedType.Interface)]
                out System.Runtime.InteropServices.ComTypes.IDataObject ppDORet);
	}


	#region Struct

	[StructLayout(LayoutKind.Sequential)]
	public struct DOCHOSTUIINFO
	{
		public uint cbSize;
		public uint dwFlags;
		public uint dwDoubleClick;
		[MarshalAs(UnmanagedType.BStr)]
		public string pchHostCss;
		[MarshalAs(UnmanagedType.BStr)]
		public string pchHostNS;
	}

	#endregion

	#region Enums

	public enum DOCHOSTUITYPE
	{
		DOCHOSTUITYPE_BROWSE = 0,
		DOCHOSTUITYPE_AUTHOR = 1
	}

	public enum DOCHOSTUIDBLCLK
	{
		DOCHOSTUIDBLCLK_DEFAULT = 0,
		DOCHOSTUIDBLCLK_SHOWPROPERTIES = 1,
		DOCHOSTUIDBLCLK_SHOWCODE = 2
	}

	[Flags]
	public enum DOCHOSTUIFLAG
	{
		DOCHOSTUIFLAG_DIALOG = 0x00000001,
		DOCHOSTUIFLAG_DISABLE_HELP_MENU = 0x00000002,
		DOCHOSTUIFLAG_NO3DBORDER = 0x00000004,
		DOCHOSTUIFLAG_SCROLL_NO = 0x00000008,
		DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE = 0x00000010,
		DOCHOSTUIFLAG_OPENNEWWIN = 0x00000020,
		DOCHOSTUIFLAG_DISABLE_OFFSCREEN = 0x00000040,
		DOCHOSTUIFLAG_FLAT_SCROLLBAR = 0x00000080,
		DOCHOSTUIFLAG_DIV_BLOCKDEFAULT = 0x00000100,
		DOCHOSTUIFLAG_ACTIVATE_CLIENTHIT_ONLY = 0x00000200,
		DOCHOSTUIFLAG_OVERRIDEBEHAVIORFACTORY = 0x00000400,
		DOCHOSTUIFLAG_CODEPAGELINKEDFONTS = 0x00000800,
		DOCHOSTUIFLAG_URL_ENCODING_DISABLE_UTF8 = 0x00001000,
		DOCHOSTUIFLAG_URL_ENCODING_ENABLE_UTF8 = 0x00002000,
		DOCHOSTUIFLAG_ENABLE_FORMS_AUTOCOMPLETE = 0x00004000,
		DOCHOSTUIFLAG_ENABLE_INPLACE_NAVIGATION = 0x00010000,
		DOCHOSTUIFLAG_IME_ENABLE_RECONVERSION = 0x00020000,
		DOCHOSTUIFLAG_THEME = 0x00040000,
		DOCHOSTUIFLAG_NOTHEME = 0x00080000,
		DOCHOSTUIFLAG_NOPICS = 0x00100000,
		DOCHOSTUIFLAG_NO3DOUTERBORDER = 0x00200000,
		DOCHOSTUIFLAG_DISABLE_EDIT_NS_FIXUP = 0x400000,
		DOCHOSTUIFLAG_LOCAL_MACHINE_ACCESS_CHECK = 0x800000,
		DOCHOSTUIFLAG_DISABLE_UNTRUSTEDPROTOCOL = 0x1000000
	}

	#endregion
}
